Base Distribution - Task # 42014

Story # 44957 (New): Reliable clipboard and content element handles

Status: Resolved Priority: Must have
Author: Christopher Hlubek Category:

Created: 2012-10-15 Assigned To:

Updated: 2013-05-23 Due date:

Subject: Cut and Paste is not working reliably

Description

Associated revisions

Revision f90106df - 2012-11-08 16:00 - Christopher Hlubek

[BUGFIX] Use buttons in content element handles for actions

Change-Id: le6d288d5504cc78b584a356f2ca8c0b6cdb2b042

Related: #42014

Revision ¢3868172 - 2013-09-01 14:22 - Mattias Nilsson

[TASK] Fix TODO abour removal of workaround for cut and paste

In the Application.js there is a comment referring
to the issue http://forge.typo3.org/issues/42014

Change-Id: 1ffd1631c73f39¢c2b4077ce0d6eb55c¢592b1bd996
Related: #42014
Reviewed-on: https://review.typo3.org/23527

Reviewed-by: Aske Ertmann
Tested-by: Aske Ertmann

History

#1 - 2012-11-07 17:58 - Mattias Nilsson

- Assigned To set to Mattias Nilsson

#2 - 2012-11-07 17:58 - Mattias Nilsson

- Status changed from New to Accepted

#3 - 2012-11-07 19:26 - Mattias Nilsson

During the testing of the cut/copy and paste methods it was not possible to recreate the errors. | have tried in the latest version of Google Chrome and

Firefox.

The icons was behaing as expected, the content was put on the correct position and the content was rendered as it was before the action.

#4 - 2012-11-07 19:26 - Mattias Nilsson
- Status changed from Accepted to Needs Feedback
#5 - 2012-11-08 10:53 - Christopher Hlubek

I'll do another test today.

#6 - 2012-11-08 14:52 - Christopher Hlubek

| still get errors:

(in ember-0.9.7.js:16440)

Uncaught Error: Cannot perform operations on a Metamorph that is not in the DOM.

And the buttons do not work reliably for me (sometimes a click is just not registered) and the paste icon is not shown, even if cut / copy is shown as

pressed.
If | unpress the cut icon after the error | get another exception:
DEPRECATION: Something you did caused a view to re-render after it rendered but before it was inserted into the DOM. Because this is

avoidable and the cause of significant performance issues in applications, this behavior is deprecated. If you want to use the debugger to find
out what caused this, you can set ENV.RAISE_ON_DEPRECATION to true.

#7 - 2012-11-08 15:15 - Christopher Hlubek

One thing is a Ul issue: the Ember action is bound to the icon instead of the button, this can be changed easily. Another thing is that after a successful

cut / paste a page reload occurs and the bugs appear.

#8 - 2012-11-08 15:38 - Christopher Hlubek

It seems that the Ember view is not removed after the page gets reloaded. Which causes problems, because Ember bindings are still active and are

triggered if the cut button is pressed, so the not visible handles will try to update the DOM, which is detected and complained about in Metamorph.

We should try to correctly remove any Ember view on a reload of a content element.

#9 - 2012-11-08 15:54 - Christopher Hlubek
| tried to remove all Ember views after a page load, but that doesn't help (I don't really understand why).
The only solution | see is to change the clipboard handling:

- Use one handles view for all content elements

- Bind the view to the selectedNode

- Re-position the view on selection of a node (could be observed)

- With proper bindings the view should update the button states depending on the selected node or clipboard content

#10 - 2012-11-08 23:24 - Aske Ertmann
#7 is fixed with https://review.typo3.org/#/c/16317/

| can reproduce the problems Christopher is having. Before pasting an element | sometimes can have something cut/copied but unable to paste it
anywhere, but where i cut/copied it. After pasting an element | get the same exception "Uncaught Error: Cannot perform operations on a Metamorph
that is not in the DOM." and the same when uncutting/uncopying..

| hope we can do something else to get rid of the views that has been removed, since this will probably not be the only place we'll have that problem..

| googled "emberjs Cannot perform operations on a Metamorph that is not in the DOM" and there are some stuff we could try..

#11 - 2013-01-22 11:54 - Christopher Hlubek

Aske Ertmann wrote:

I hope we can do something else to get rid of the views that has been removed, since this will probably not be the only place we'll have that

problem..

What about my idea to change the handles to only one Ember view that gets assigned to a node on selection? | feel this could be a more robust
solution especially with dynamic reloading of content.

#12 - 2013-01-23 16:03 - Mattias Nilsson
- Assigned To deleted (Mattias Nilsson)

#13 - 2013-01-30 10:27 - Christopher Hlubek
- Parent task changed from #41101 to #44957

#14 - 2013-01-30 10:29 - Christopher Hlubek
- Assigned To set to Rens Admiraal
- Priority changed from Should have to Must have

#15 - 2013-04-05 11:44 - Mattias Nilsson

- Status changed from Needs Feedback to Resolved
- Assigned To deleted (Rens Admiraal)

This issue is solved in: https://review.typo3.org/#/c/19306/

#16 - 2013-04-05 12:10 - Mattias Nilsson
- % Done changed from 0 to 100

#17 - 2013-05-23 18:52 - Jacob Floyd

I just noticed a comment in Application.js! that suggests that the workaround might not be necessary once this bug is fixed. Now this issue is fixed, is
the hack in [1] necessary?

[1] https://qit.typo3.org/FLOW3/Packages/TYPO3.TYPOS3.git/blob/HEAD:/Resources/Public/JavaScript/Content/Application.js#1299
